<?php 
	$queries=explode('&',$_SERVER['QUERY_STRING']);
	foreach($queries as $val) {
		$tmp=explode('=', $val);
		if (count($tmp)>1) 
			$_GET[$tmp[0]]=$tmp[1];
	} 
	foreach($_GET as $key => $val)
	 ${$key}=$val;
?>
<?php
/*
 * Created on 7 Jun 2007 
 * By julien reichel <julien.reichel@spinetix.com>
 * This script generate a status screen from a set of inpot variables and system informations
 * 
 * The script recived a set of global variable which are set by the svgreporting class:
 * Example fo variables are :
 *  $topLeftText="SpinetiX";
 * 	$topRightText="Bonsai";
 *  $bottomText="Powered By SpinetiX";
 *  $deviceName="No Name";
 * 	$ipadress=???
 * 
 * An object ($sysinfo) can be used to get information from the system in an OS independant manner
 * 
 * Each system info is shown using the function drawitem(). The function expect an icon and a list of parameters as shown below:
 * $icons="hdmi.png";
 * $param['info']="display";
 * $param['width']=$width;
 * $param['height']=$height;
 * drawitem($icons, $param, $idx ,$nbitems ,$p);
 * 
 * All parameter of $param will be passed to the script "info.php" to be displayed, using an external script allows for the update of the displayed 
 * parameter each time they are shown, whereas the overall structure (this scrupt) is refresed only once all items have been shown
 */
 
function drawitem($icon,$text, $index, $nbitem,$p, $isfront=0){
	global $reportName;
	global $generateInfo;

	$duration=10;
	$pause=0;
	
	$scale=0.25;
	
	$totalDur=($duration+$pause)*$nbitem;
	$offset=-$index*($duration+$pause);
	$repeat=$totalDur-$offset;
		
	$position=0.21;
	$posstart=0.0;
	$posend=0.6;
	$posvar=0.02;
	$transin=$duration*0.1;
	$zoomin=$duration*0.1;
	$transout=$duration*0.1;
	//helper
	
	$speed=($posstart+1-$posend)/($totalDur-$duration)*$totalDur;
	$timestart=$posstart/$speed;
	
	$timeend=$timestart+$duration/$totalDur;
	$fixstart=$timestart+$transin/$totalDur;
	$fixend=$timeend-$transout/$totalDur;
	//$startTime=$fixstart*$totalDur+$offset;
	//$animtime=$duration-$transout-$transin;
	
	$zoomstart=$fixstart-$zoomin/$totalDur;
	$zoomover1=$fixstart-($fixstart-$zoomstart)*0.05;
	$zoomover2=$fixstart+($fixstart-$zoomstart)*0.05;
	
	$posin=$position-$posvar;
	$posout=$position+$posvar;
	$path="M 1061.8713,254.87107 C 1083.0924,319.29617 923.61843,436.88479 705.90272,517.34572 C 488.18696,597.80669 294.26726,610.82133 273.0462,546.39624 C 251.82512,481.97117 411.29905,364.38252 629.01475,283.92157 C 846.73051,203.46062 1040.6502,190.44599 1061.8713,254.87107";
		
	$elem='image';
	// what is the icon (we support gif, svg and other image)
	$ext=substr($icon,strrpos($icon,'.')+1);
	
	switch ($ext){
		case "svgx":
		case "svg": $elem='animation'; break;
		case "gif": $elem='video'; break;
	}
	
	print("<$elem dur='$totalDur' xlink:href='../$icon' width='275' height='220' x='-275' y='-220'>\n");
	print("<animateTransform begin='$offset' repeatDur='$repeat' attributeName='transform' type='scale' dur='$totalDur' keyTimes='0;$zoomstart;$zoomover1;$zoomover2;$fixend;$timeend;1' values='$scale;$scale;1.1;1;1;$scale;$scale' fill='freeze'/>\n");
	print("<animateMotion begin='$offset' repeatDur='$repeat' calcMode='linear' dur='$totalDur' keyTimes='0;$timestart;$fixstart;$fixend;$timeend;1' keyPoints='0;$posstart;$posin;$posout;$posend;1' path='$path' />");
	if ($isfront)
		print("<animate attributeName='display' values='none;inherit;none;none' keyTimes='0;$timestart;$timeend;1' begin='$offset' repeatDur='$repeat' dur='$totalDur'/>\n");
	else
		print("<animate attributeName='display' values='inherit;none;inherit;inherit' keyTimes='0;$timestart;$timeend;1' begin='$offset' repeatDur='$repeat' dur='$totalDur'/>\n");
	print("</$elem>\n");
	
	if ($offset==0)
		$begin=0;
	else
		$begin=$totalDur+$offset;
	$add="begin='$begin' dur='$duration'";
	if (count($text)>0){
		print("<animation $add display='none' xlink:href='../info.php");
		$init=1;
		$text['dur']=$duration;
		$text['docwidth']=$p['w'];
		$text['docheight']=$p['h'];
		$text['reportName']=$reportName;
		if (!isset($generateInfo))$text['noSave']=1;
		foreach ($text as $key => $val) {
			if($init) print("?");
			else print("&amp;");
			print ($key."=".$val);
			$init=0;
		}
		print("' x='".$p['x']."' y='".$p['y']."' width='".$p['w']."' height='".$p['h']."'>\n");
		print("<animate attributeName='display' values='none;inherit;none;none' keyTimes='0;$timestart;$timeend;1' begin='$offset' repeatDur='$repeat' dur='$totalDur'/>\n");
		// animation can not have "opacity"
		//print("<animate attributeName='opacity' values='0;0;1;1;0;0' keyTimes='0;$timestart;$fixstart;$fixend;$timeend;1' begin='$offset' repeatDur='$repeat' dur='$totalDur'/>\n");
		print("</animation>\n");
	}
 }

function to_readble_size($Bytes,$sufix="B")
{
  $Type=array("", "K", "M", "G", "T", "P", "E", "Z", "Y");
  $Index=0;
  while($Bytes>=1024)
  {
    $Bytes/=1024;
    $Index++;
  }
  $pre=0;
  if ($Bytes<100)
  	$pre++;
  if ($Bytes<10)
  	$pre++;
  $Bytes=round($Bytes,$pre);
  if ($sufix=="")
  	return($Bytes);
  else
  	return("".$Bytes." ".$Type[$Index].$sufix);
}

print("<?xml version=\"1.0\"?>");

include "sysinfo.php";
 
$sysinfo= new sysinfo();
 

$docwidth=1280;
$docheight=720;


if (!isset($backgroundPath)) $backgroundPath="../status_bck.png";
if (!isset($topLeftText)) $topLeftText="SpinetiX";
if (!isset($topRightText)) $topRightText="HMP-100 Remote";
if (!isset($bottomText)) $bottomText="Powered By SpinetiX";
if (!isset($baseScriptPath)) $baseScriptPath="/srv/raperca/status/";
if (!isset($reportName)) $reportName=$baseScriptPath."device.xml";

// try to pre-load the report file
if (isset($generateInfo))
	$sysinfo->readReport($reportName);


if (isset($renderwidth)) $sysinfo->info['display']['renderwidth']=$renderwidth;	
if (isset($renderheight))	$sysinfo->info['display']['renderheight']=$renderheight; 
if (isset($renderfreq))	$sysinfo->info['display']['renderfreq']=$renderfreq; 
if (isset($renderAspectRatio))	$sysinfo->info['display']['renderAspectRatio']=$renderAspectRatio; 
if (isset($renderUnderscan))	$sysinfo->info['display']['renderUnderscan']=$renderUnderscan; 

$sysinfo->info['config']['reportName']=$reportName;
$sysinfo->info['config']['localPath']=$baseScriptPath;


if (isset($serverPath)) $sysinfo->info['disk']['serverPath']=$serverPath; //else $sysinfo->info['disk']['serverPath']=realPath($baseScriptPath.'../content/');
if (isset($usbPath)) $sysinfo->info['disk']['usbPath']=$usbPath;

if (isset($ipadress)) $sysinfo->info['network']['ipaddress']=$ipadress;
if (isset($ipaddress)) $sysinfo->info['network']['ipaddress']=$ipaddress;
if (isset($hostname)) $sysinfo->info['network']['hostname']=$hostname;

$i=0;
$sysinfo->info['player']['virtualHost']=array();	
while (isset(${'host'.$i})){
	$val=array();
	$val['host']=${'host'.$i};
	$val['href']=${'href'.$i};
	$sysinfo->info['player']['virtualHost'][]= $val;
	$i++;
} 
$i=0;
$sysinfo->info['player']['device']=array();	
while (isset(${'device'.$i})) $sysinfo->info['player']['device'][]= ${'device'.$i++};
$i=0;
$sysinfo->info['player']['source']=array();	
while (isset(${'source'.$i})) $sysinfo->info['player']['source'][]= ${'source'.$i++};
$i=0;
$sysinfo->info['player']['connectedServer']=array();	
while (isset(${'connectedServer'.$i})) $sysinfo->info['player']['connectedServer'][]= ${'connectedServer'.$i++};
$i=0;	
$sysinfo->info['modules']['module']=array();
while (isset(${'module'.$i})) $sysinfo->info['modules']['module'][]= ${'module'.$i++};

if (isset($statusPath)) $sysinfo->info['server']['statusPath']= $statusPath;
if (isset($configPath)) $sysinfo->info['config']['configPath']= $configPath;
if (isset($playingSource)) $sysinfo->info['player']['playingSource']= $playingSource;

if (isset($averageRenderTime_ms)) $sysinfo->info['player']['averageRenderTime_ms']= $averageRenderTime_ms;
if (isset($lastSecRenderTime_ms)) $sysinfo->info['player']['lastSecRenderTime_ms']= $lastSecRenderTime_ms;
if (isset($totalRenderTime_s)) $sysinfo->info['player']['totalRenderTime_s']= $totalRenderTime_s;
if (isset($totalRenderPictures)) $sysinfo->info['player']['totalRenderPictures']= $totalRenderPictures;



// create the report file
if (!isset($generateInfo)){
	if (!isset($TEMPLATEfilename)) $TEMPLATEfilename=$argv[1];
	$sysinfo->readReport($TEMPLATEfilename);
	$sysinfo->saveReport($reportName);
	print("<!-- Read $TEMPLATEfilename save $reportName -->\n");
}else{
	$sysinfo->scriptPath="../reporting.phpt";
	$sysinfo->genReport();
	$sysinfo->saveReport($reportName);
	print("<!-- Save info $sysinfo->scriptPath in $reportName -->\n");
}
$margin=12;

// the document:

print("<svg xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' width='100%' height='100%' viewBox='0 0 $docwidth $docheight'>\n");
// the gradients
print("<defs id='Gradients'>\n");
print("<linearGradient id='GradEllipse1'><stop style='stop-color:white;stop-opacity:0.21649484' offset='0' id='stop24816' /><stop style='stop-color:#2723e9;stop-opacity:0.93814433' offset='1' id='stop24818' /></linearGradient>\n");
print("<linearGradient x1='300' y1='112.029' x2='300' y2='0' id='GradTitle' gradientUnits='userSpaceOnUse'><stop style='stop-color:#0096b0;stop-opacity:1' offset='0' /><stop style='stop-color:#00b4d4;stop-opacity:1' offset='0.180392'/> <stop style='stop-color:#63e8ff;stop-opacity:1' offset='0.50196099' id='stop19308' /> <stop style='stop-color:#00b4d4;stop-opacity:1' offset='0.78823501' id='stop19310' /> <stop style='stop-color:#008299;stop-opacity:1' offset='1'/> </linearGradient> \n");
print("<radialGradient cx='331.62567' cy='232.87511' r='171.06445' fx='331.62567' fy='232.87511' id='GradMid' xlink:href='#GradEllipse1' gradientUnits='userSpaceOnUse' gradientTransform='matrix(2.647226,-0.958006,0.260445,0.874081,-298.5392,488.7676)' /> \n");
print("<linearGradient x1='307.3114' y1='77.019524' x2='307.3114' y2='505.71591' id='GradTop' xlink:href='#GradTitle' gradientUnits='userSpaceOnUse' gradientTransform='matrix(2,0,0,0.145833,0,1.62931)' /> \n");
print("</defs>\n");

// the baground image:
print("<image preserveAspectRatio='none' xlink:href='$backgroundPath' x='0' y='0' width='$docwidth' height='$docheight'/>\n");

// the title:
print("<g fill='black' fill-opacity='1' font-family='Arial' font-size='30px' font-style='italic' font-weight='bold'>\n");
print("<rect width='$docwidth' height='70' x='0' y='0' style='fill:url(#GradTop)' id='GradienTitle' />\n");

print("<text x='$margin' y='45' text-align='begin' text-anchor='begin'>$topLeftText</text>\n");
print("<text x='".($docwidth-$margin)."' y='45' text-align='end' text-anchor='end'>$topRightText</text>\n");

// the time
$centerpos=$docwidth/2;
print("<animation height='70' width='$docwidth' xlink:href='../time.php?y=45&amp;docwidth=$docwidth&amp;docheight=70&amp;x=$centerpos&amp;text_align=center&amp;text_anchor=middle&amp;font_size=30px&amp;font_weight=bold' />\n");

print("<text x='$margin' y='".($docheight-$margin)."' text-align='begin'>$bottomText</text>\n");
print("</g>");
   
// the static info
$x=10;
$y=60;
$w=400;
$h=140;

print("<animation xlink:href='../info.php");
$text=array();
$text['info']='Device Info';
$text['docwidth']=$w;
$text['docheight']=$h;
$text['reportName']=$reportName;
if (!isset($generateInfo))$text['noSave']=1;
$init=1;
foreach ($text as $key => $val) {
	if($init) print("?");
	else print("&amp;");
	print ($key."=".$val);
	$init=0;
}
print("' x='$x' y='$y' width='$w' height='$h' dur='10s' fill='freeze'/>\n");

print("<g transform='translate(-170,-50)'>");
// the ellipse
$path="M 1090.1991,211.69725 C 1114.4217,292.99099 932.39142,431.95786 683.88157,521.89119 C 435.37164,611.82456 214.02355,618.83644 189.80093,537.54268 C 165.57831,456.24896 347.60856,317.28207 596.11841,227.34872 C 844.62834,137.41536 1065.9764,130.40349 1090.1991,211.69725";
print("<path d='$path z' style='fill:url(#GradMid);fill-opacity:1;stroke:white;stroke-width:7;stroke-opacity:1' id='ellipse' />\n");

// dynamic info
$p['x']=890;
$p['y']=420;
$p['w']=540;
$p['h']=330;


$icons=array();
$param=array();
$idx=0;

//======================================================================
// Display Categories as illustrated in http://idefix.spinetix.local/twiki/bin/view/Main/GenesisDeviceStatus topic.
// Each category is represented by an ICON 
// (or a set of icons that specify a status according to some criteria)
// The ICON can be associated to an info box using the $param[$idx]['info'].
// The value you set can be used to call a specific function in info.php that will animate the appearance of the details.  
//======================================================================

$renderinginfo=true;
$OSinfo=false;
//******************* Rendering Info ***********************************//
if ($renderinginfo) {
	$icons[$idx]="displayresolution.svg";
	$param[$idx]['info']="Rendering";
	$idx++;
}

//******************* Display ***********************************//
$detectedHDMI = false;
$detectedVGA = false;

if ($detectedHDMI) {
	$icons[$idx]="hdmi.svg";
	$param[$idx]['info']="HDMI Display";
	$idx++;
}

if ($detectedVGA) {
	$icons[$idx]="vga.svg";
	$param[$idx]['info']="VGA Display";
	$idx++;
}

//************ Network Connectivity ******************************************//
$detectedWiredNetwork = false;
if ($detectedWiredNetwork) {
	if ($sysinfo->info['network']['ipaddress']=="127.0.0.1")
		$icons[$idx]="network-wired-unplugged.svg";
	if (count($sysinfo->info['network']['interface'])==0)
		$icons[$idx]="network-wired-error.svg";	
	$icons[$idx]="network-wired.svg";	
	$param[$idx]['info']="Wired network";
	$idx++;
}

//************* Software modules *****************************************//
$icons[$idx]="sysinfo.svg";
$param[$idx]['info']="Versions";
$idx++;

//************* Software modules *****************************************//
$icons[$idx]="software.svg";
$param[$idx]['info']="Software modules";
$idx++;

//***************** Hardware *************************************//
$icons[$idx]="hardware.svg";
$param[$idx]['info']="Hardware info";
$idx++;

// ************** USB Interfaces **************************************** //
$icons[$idx]="usb.svg";
$param[$idx]['info']="USB devices";
$idx++;

//**************  Storage  ****************************************//
$percentage_free	 = 100-$sysinfo->info['disk']['server']['percent'];
if ($percentage_free<12) $icons[$idx]="storage_bad.svg";
elseif ($percentage_free<37) $icons[$idx]="storage_75.svg";
elseif ($percentage_free<62) $icons[$idx]="storage_50.svg";
elseif ($percentage_free<87) $icons[$idx]="storage_25.svg";
else $icons[$idx]="storage_0.svg";
$param[$idx]['info']="Mass storage";
$idx++;

//**************  SD Cards  ****************************************//
$detectedSD = false;
if ($detectedSD) {
	$icons[$idx]="sd.svg";
	$param[$idx]['info']="SD cards";
	$idx++;
}

$nbitems=count($icons);
for ($i=0; $i<$nbitems; $i++)
	drawitem($icons[$i], $param[$i], $i ,$nbitems ,$p);

// make sure that the fronts are in front
$text=array();
for ($i=0; $i<$nbitems; $i++)
	drawitem($icons[$i], $text, $i ,$nbitems ,$p,1);

print("</g>");
print("</svg>");

?>


